#include "config.h"
#include <stdlib.h>
#include "ll.h"

LPLIST ListCreate(NODEFREEFUNC pFunc,size_t objSize)
{
  LPLIST pList;
  
  /* now allocate the object */
  pList = (LPLIST)malloc(objSize);
  if (pList)
  {
    pList->pHead = NULL;
    pList->pTail = NULL;
    pList->pFree = pFunc;
    pList->uCount = 0;
  }
  return pList;
}

LPNODE ListCreateNode(LPLIST pList,size_t objSize)
{
  /* return object */
  return (LPNODE)malloc(objSize);
}

void ListDestroy(LPLIST pList)
{
  LPNODE iter = pList->pHead;
  LPNODE next;
  while (iter)
  {				
    /* store value */
    next = iter->pNext;
    /* free memory */
    if (pList->pFree)
    {
      pList->pFree(iter);
    }
    free(iter);
    /* update value */
    iter = next;
  }
  /* free the list now */
  free(pList);
}

void ListAddTail(LPLIST pList,LPNODE pNode)
{
  pNode->pNext = NULL;
  
  /* increment the count */
  pList->uCount++;
  
  /* link up the item */
  if (pList->pTail)
  {
    pList->pTail->pNext = pNode;
    pList->pTail = pNode;
  }
  else
  {
    pList->pHead = pList->pTail = pNode;
  }
}
